import akka.actor.typed.scaladsl.Behaviors
import akka.actor.typed.{Behavior, ActorRef, ActorSystem}
import akka.actor.testkit.typed.scaladsl.ActorTestKit


enum Message:
  case Count
  case Get(n: ActorRef[Int])

def counter(count: Int): Behavior[Message] = Behaviors.receiveMessage {
  case Message.Count =>
    counter(count + 1)
  case Message.Get(sender) =>
    sender ! count
    Behaviors.same
}

@main def main() = 
  val testkit = ActorTestKit("hello")
  val c = testkit.spawn(counter(0))
  c ! Message.Count
  c ! Message.Count
  c ! Message.Count
  val p = testkit.createTestProbe[Int]()
  c ! Message.Get(p.ref)
  println(p.receiveMessage())
  testkit.shutdownTestKit()